/*
 * postscript interface
 */

#ifndef PS_INT_H
#define PS_INT_H 

#include "util.h"
#include "attr.h"
#include "matrix.h"

class ps_int : public gfx_int {
	ostream &o;
	ostringstream *fig;
	double x1, y1, x2, y2;
	vec last_pos;
	
	void clip (const vec &v) t_no;
	void check_attrs (const attribute_set &attr) t_err;
public:
	ps_int (ostream &out) t_no;
	~ps_int () t_no;
	
	void begin_fig () t_no;
	void end_fig () t_no;
	
	void segment (const point &a, const point &b) t_err;
	void object (const points &v) t_err;
};

#endif
