/*
 * rayshade interface
 */

#ifndef RAY_INT_H
#define RAY_INT_H 

#include "interface.h"
#include "attr.h"
#include "matrix.h"

using namespace std;

class ray_int : public gfx_int {
	ostream &o;
	
	vec diffuse;
	vec color;
	double width;
	
	double x1, y1, z1, x2, y2, z2;
	
	void clip (const vec &v) t_no;
	void check_attrs (const attribute_set &attr) t_err;
public:
	ray_int (ostream &out) t_no;
	~ray_int () t_no;
	
	void begin_fig () t_no;
	void end_fig () t_no;
	
	void segment (const point &a, const point &b) t_err;
	void object (const points &v) t_err;
};

#endif
